var assessmentReport = requirejs.config({
	context: "assessmentReport",
	baseUrl: path,
	paths: {
		'jquery': 'jquery',
		'jquery.mobile': 'lib/jquery/jquery.mobile',
		'jquery.highlight': 'plugins/jquery.highlight',
		'widgets': 'widgets',
		'views': 'views',
		'plugins': 'plugins',
		'controllers': 'controllers'
	},
	shim: {
		'jquery.highlight': {
			deps: ['jquery'],
			exports: 'jQuery.fn.highlight'
		},
		'jquery.mobile': {
			deps: ['jquery'],
			exports: 'jQuery'
		}
	}
});
assessmentReport(['widgets/Header', 'plugins/text!widgets/templates/AssessmentHeader.html', 'plugins/text!widgets/templates/SectionHeader.html', 'plugins/text!widgets/templates/QuestionDetail.html', 'plugins/text!widgets/templates/SectionFooter.html', 'plugins/text!widgets/templates/AssessmentFooter.html', 'plugins/domReady'], function(Header, assessmentHeaderTemplate, sectionHeaderTemplate, questionTemplate, sectionFooterTemplate, assessmentFooterTemplate, domReady) {
	if (typeof jQuery != "undefined") {
		jQuery.ajaxSetup({
			dataFilter: function(jsonString, type) {
				var result = jsonString;
				if (type == "json") {
					result = JSONUtil.removeTaintedValue(result);
				}
				return result;
			}
		});
	};
	domReady(function() {
		var assessmentContext = getUrlParameter("assessmentContext");
		if (assessmentContext == "true") {
			jQuery(".btn-success").attr('disabled', true);
		}
		var mainHeader = new Header({
			title: jQuery("header").find(".navbar-title").html(),
			controlsDisabled: true
		});
		jQuery("header").append(mainHeader.domNode);
		var sections = sa.children;
		var assessmentHeader = jQuery(assessmentHeaderTemplate).clone();
		jQuery(assessmentHeader).find(".assessment-results-percentage").text((Math.round(sa.score * 100 * 100) / 100) + '%');
		jQuery(".assessment-results-table").append(assessmentHeader.html());
		var questionCnt = 0;
		for (var section = 0; section < sections.length; section++) {
			var sectionHeader = jQuery(sectionHeaderTemplate).clone();
			jQuery(sectionHeader).find(".section-label").text(sections[section].label);
			jQuery(".assessment-report").append(sectionHeader.get());
			var questions = sections[section].children;
			for (var question = 0; question < questions.length; question++) {
				questionCnt++;
				var detailTemplate = jQuery(questionTemplate).clone();
				jQuery(detailTemplate).find(".question-number").text(questionCnt + ". ");
				jQuery(detailTemplate).find(".question-stem").text(questions[question].label);
				jQuery(detailTemplate).find(".question-score").text((Math.round(questions[question].result * 100 * 100) / 100) + '%');
				jQuery(".assessment-report").append(detailTemplate.get());
			}
			var sectionFooter = jQuery(sectionFooterTemplate).clone();
			jQuery(sectionFooter).find(".section-score").text((Math.round(sections[section].score * 100 * 100) / 100) + '%');
			jQuery(".assessment-report").append(sectionFooter.get());
		}
		var assessmentFooter = jQuery(assessmentFooterTemplate).clone();
		jQuery(assessmentFooter).find(".assessment-score").text((Math.round(sa.score * 100 * 100) / 100) + '%');
		jQuery(".assessment-report").append(assessmentFooter.get());
	});
});
/* supporting function added to the assessmentReports object to navigate back to the main course content */
if (!window.assessmentReports) {
	window.assessmentReports = {};
}
window.assessmentReports.navigateToCourse = function() {
	document.location.href = document.location.href = "ContentViewer?objectID=" + localStorage["responsiveViewer.rootCourseId"] + "&otId=1&viewerID=" + viewerId + "&themeID=" + window.assessmentReports.getThemeId() + "&srcId=3&filterID=null&substitutionProID=all";
};
window.assessmentReports.retakeAssessment = function() {
	var args = [];
	args.push("studentID=" + assessmentReports.studentId);
	args.push("assessID=" + assessmentReports.assessmentId);
	args.push("courseID=" + assessmentReports.courseId);
	args.push("themeID=" + assessmentReports.themeId);
	args.push("objectID=" + localStorage["responsiveViewer.rootCourseId"]);
	args.push("objectTypeID=" + assessmentReports.parentObjectTypeId);
	args.push("viewerID=" + viewerId);
	args.push("doModal=false");
	args.push("showCloseBtn=true");
	document.location.href = "BuildAssessment?" + args.join("&");
};

function getUrlParameter(sParam) {
	var sPageURL = document.location.href;
	var sURLVariables = sPageURL.split('&');
	for (var i = 0; i < sURLVariables.length; i++) {
		var sParameterName = sURLVariables[i].split('=');
		if (sParameterName[0] == sParam) {
			return sParameterName[1];
		}
	}
};
